# ---------------------------------------------------------------------
# Copyright (c) 2017 Kim Peter Wabersich, email: wabersich@kimpeter.de
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
# -----------------------------------------------------------------
from .. import IntegerGrid
import unittest


class TestIterateGrid(unittest.TestCase):
    def test_count_one_digit(self):
        # create object
        integer_grid = IntegerGrid.IntegerGrid(1, [0], [3])

        self.assertEqual(integer_grid.x_[0], 0)
        integer_grid.count()
        self.assertEqual(integer_grid.x_[0], 1)
        integer_grid.count()
        self.assertEqual(integer_grid.x_[0], 2)
        integer_grid.count()
        self.assertEqual(integer_grid.x_[0], 3)
        integer_grid.count()
        self.assertEqual(integer_grid.x_[0], 0)

    def test_count_three_digit(self):
        # create object
        integer_grid = IntegerGrid.IntegerGrid(3, [0, 0, 0], [1, 1, 1])

        self.assertEqual(integer_grid.x_[0], 0)
        self.assertEqual(integer_grid.x_[1], 0)
        self.assertEqual(integer_grid.x_[2], 0)
        integer_grid.count()

        self.assertEqual(integer_grid.x_[0], 0)
        self.assertEqual(integer_grid.x_[1], 0)
        self.assertEqual(integer_grid.x_[2], 1)
        integer_grid.count()

        self.assertEqual(integer_grid.x_[0], 0)
        self.assertEqual(integer_grid.x_[1], 1)
        self.assertEqual(integer_grid.x_[2], 0)
        integer_grid.count()

        self.assertEqual(integer_grid.x_[0], 0)
        self.assertEqual(integer_grid.x_[1], 1)
        self.assertEqual(integer_grid.x_[2], 1)
        integer_grid.count()

        self.assertEqual(integer_grid.x_[0], 1)
        self.assertEqual(integer_grid.x_[1], 0)
        self.assertEqual(integer_grid.x_[2], 0)
        integer_grid.count()

        self.assertEqual(integer_grid.x_[0], 1)
        self.assertEqual(integer_grid.x_[1], 0)
        self.assertEqual(integer_grid.x_[2], 1)
        integer_grid.count()

        self.assertEqual(integer_grid.x_[0], 1)
        self.assertEqual(integer_grid.x_[1], 1)
        self.assertEqual(integer_grid.x_[2], 0)
        integer_grid.count()

        self.assertEqual(integer_grid.x_[0], 1)
        self.assertEqual(integer_grid.x_[1], 1)
        self.assertEqual(integer_grid.x_[2], 1)
        integer_grid.count()

        self.assertEqual(integer_grid.x_[0], 0)
        self.assertEqual(integer_grid.x_[1], 0)
        self.assertEqual(integer_grid.x_[2], 0)
        integer_grid.count()


if __name__ == '__main__':
    unittest.main()
